/* 
 * Copyright 2012 by AVM GmbH <info@avm.de>
 *
 * This software contains free software; you can redistribute it and/or modify 
 * it under the terms of the GNU General Public License ("License") as 
 * published by the Free Software Foundation  (version 3 of the License). 
 * This software is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the copy of the 
 * License you received along with this software for more details.
 */

package de.avm.android.tr064.soap;

import java.io.IOException;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import de.avm.android.tr064.exceptions.BaseException;
import de.avm.android.tr064.exceptions.DataMisformatException;

/* Soap implementation for the VoIPConf-Interface */
public class GetVoIPConfNumberOfClients extends VoIPConfSoapHelper<Integer>
{
	public GetVoIPConfNumberOfClients(ISoapCredentials soapCredentials)
	{
		super(soapCredentials);
	}

	@Override
	public Integer getQualifiedResult()
			throws DataMisformatException, BaseException, IOException
	{
		String input = getSoapBody();
		Matcher m = Pattern.compile("NewX_AVM-DE_NumberOfClients>(.*?)<\\/NewX_AVM-DE_NumberOfClients")
				.matcher(input);
		if (m.find())
		{
			try
			{
				return Integer.parseInt(m.group(1));
			}
			catch(NumberFormatException  exp)
			{
				throw new DataMisformatException("Invalid Response from VoIPConf Service", exp);
			}
		}
		else throw new DataMisformatException("Invalid Response from VoIPConf Service");
	}

	@Override
	public String getSoapMethod()
	{
		return "X_AVM-DE_GetNumberOfClients";
	}
}